package com.npa.eir.system;

package ..deTemp.1734568884231;

import com.npa.eir.transaction.Empty_ctn_eir_job_setting;
import com.npa.eir.transaction.Empty_ctn_eir_receive;
import com.npa.eir.transaction.Empty_ctn_eir_xml;
import com.npa.json.transaction.CancelTTBookingInfoInvokeWS;
import com.npa.json.transaction.MessageReturnInvokeWS;
import com.npa.json.transaction.MessageReturnPre;
import com.npa.json.transaction.SendTTBookingInfoInvokeWS;
import com.npa.json.transaction.SendTransTimeInvokeWS;
import com.npa.npp.system.AVariableSet;
import com.npa.npp.system.ConnPoolHandler;
import com.npa.npp.system.Log;
import com.npa.npp.system.SocketRecvHandler;
import com.npa.singlewindow.transaction.BargeCtnByAmountInvokeWS;
import com.npa.singlewindow.transaction.CtOutInvokeWS;
import com.npa.singlewindow.transaction.SendFeeInvokeWs;
import com.npa.singlewindow.transaction.SendHtCheckWs;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.Socket;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.text.ParseException;
import org.quartz.CronTrigger;
import org.quartz.Job;
import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.SchedulerException;
import org.quartz.SchedulerFactory;
import org.quartz.Trigger;
import org.quartz.impl.StdSchedulerFactory;

public class ServiceServer extends Thread {
  public Socket client;
  
  public DataOutputStream out;
  
  public DataInputStream in;
  
  public byte[] buffer;
  
  public static SchedulerFactory sf;
  
  public static String JOB_GROUP_NAME = "group";
  
  public static String TRIGGER_GROUP_NAME = "trigger";
  
  public String receiveTime = null;
  
  public String sendTime = null;
  
  public String receiveFolder = null;
  
  public String receiveHis = null;
  
  public String receiveError = null;
  
  public String sendFolder = null;
  
  public void run() {
    Connection conn = null;
    PreparedStatement st_query = null;
    ResultSet rs = null;
    try {
      System.out.println("ServiceServer start.......");
      sf = (SchedulerFactory)new StdSchedulerFactory();
      Scheduler sched = sf.getScheduler();
      conn = getConnection();
      st_query = conn.prepareStatement("select trim(T.CODE), trim(T.FILLER1) from cod_general_codes t WHERE T.CODEID='EMPTY_CTN_EIR_SET'");
      rs = st_query.executeQuery();
      while (rs.next()) {
        String code = rs.getString(1);
        String filter1 = rs.getString(2);
        if ("RECEIVE_TIME".equals(code)) {
          this.receiveTime = filter1;
          continue;
        } 
        if ("SEND_TIME".equals(code)) {
          this.sendTime = filter1;
          continue;
        } 
        if ("RECEIVE_FOLDER".equals(code)) {
          this.receiveFolder = filter1;
          continue;
        } 
        if ("RECEIVE_HIS".equals(code)) {
          this.receiveHis = filter1;
          continue;
        } 
        if ("RECEIVE_ERROR".equals(code)) {
          this.receiveError = filter1;
          continue;
        } 
        if ("SEND_FOLDER".equals(code))
          this.sendFolder = filter1; 
      } 
      if (this.receiveTime == null || this.receiveTime.equals(""))
        this.receiveTime = "0 0/5 * * * ?"; 
      if (this.sendTime == null || this.sendTime.equals(""))
        this.sendTime = "0 0/5 * * * ?"; 
      if (this.receiveFolder == null || this.receiveFolder.equals(""))
        this.receiveFolder = "D:\\edi\\INBOX"; 
      if (this.receiveHis == null || this.receiveHis.equals(""))
        this.receiveHis = "D:\\edi\\INBOXHIS"; 
      if (this.receiveError == null || this.receiveError.equals(""))
        this.receiveError = "D:\\edi\\INBOXERROR"; 
      if (this.sendFolder == null || this.sendFolder.equals(""))
        this.sendFolder = "D:\\edi\\OUTBOX"; 
      addJob("Empty_ctn_eir_xml", (Job)new Empty_ctn_eir_xml(), this.sendTime);
      addJob("Empty_ctn_eir_receive", (Job)new Empty_ctn_eir_receive(), this.receiveTime);
      addJob("Empty_ctn_eir_job_setting", (Job)new Empty_ctn_eir_job_setting(), "0 0/5 * * * ?");
      addJob("CheckBargeCtnByAmount", (Job)new BargeCtnByAmountInvokeWS(), "0 0/2 * * * ?");
      addJob("CtOutInvokeWS", (Job)new CtOutInvokeWS(), "0 0/2 * * * ?");
      addJob("MessageReturnInvokeWS", (Job)new MessageReturnInvokeWS(), "0 0/5 * * * ?");
      addJob("MessageReturnPre", (Job)new MessageReturnPre(), "0 0/5 * * * ?");
      addJob("CancelTTBookingInfoInvokeWS", (Job)new CancelTTBookingInfoInvokeWS(), "0 0/5 * * * ?");
      addJob("SendTransTimeInvokeWS", (Job)new SendTransTimeInvokeWS(), "0 0/5 * * * ?");
      addJob("SendTTBookingInfoInvokeWS", (Job)new SendTTBookingInfoInvokeWS(), "0 0/5 * * * ?");
      addJob("SendFeeInvokeWs", (Job)new SendFeeInvokeWs(), "0 0/2 * * * ?");
      addJob("SendHtCheckWs", (Job)new SendHtCheckWs(), "0 0/2 * * * ?");
      sched.getContext().put("SEND_TIME", this.sendTime);
      sched.getContext().put("RECEIVE_TIME", this.receiveTime);
      sched.getContext().put("RECEIVE_FOLDER", this.receiveFolder);
      sched.getContext().put("RECEIVE_ERROR", this.receiveError);
      sched.getContext().put("RECEIVE_HIS", this.receiveHis);
      sched.getContext().put("SEND_FOLDER", this.sendFolder);
      if (!sched.isShutdown())
        sched.start(); 
      Log.getInstance().kernel().info("eir自动接收与CBOS json已启动！");
      conn.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public static void main(String[] args) {
    com.npa.eir.system.ServiceServer s = new com.npa.eir.system.ServiceServer();
    s.run();
  }
  
  public Connection getConnection() throws Exception {
    Connection conn = null;
    if (SocketRecvHandler.getIfUseDataSource().equals("Y")) {
      conn = ConnPoolHandler.getDBInstance("1").getConnection();
    } else {
      String connect_string = 
        "jdbc:oracle:thin:hostdb/" + 

        
        AVariableSet.OraHostdbPassword + 
        "@" + 
        SocketRecvHandler.getHostIp() + 
        ":1521:" + 
        SocketRecvHandler.getHostDB();
      conn = DriverManager.getConnection(connect_string);
    } 
    return conn;
  }
  
  public static void addJob(String jobName, Job job, String time) throws SchedulerException, ParseException {
    Scheduler sched = sf.getScheduler();
    JobDetail jobDetail = 
      new JobDetail(jobName, JOB_GROUP_NAME, job.getClass());
    CronTrigger trigger = new CronTrigger(jobName, TRIGGER_GROUP_NAME);
    trigger.setCronExpression(time);
    sched.scheduleJob(jobDetail, (Trigger)trigger);
  }
  
  public static void removeJob(String jobName, String jobGroupName, String triggerName, String triggerGroupName) throws SchedulerException {
    Log.getInstance().kernel().info("移除了" + jobName + "调度器");
    Scheduler sched = sf.getScheduler();
    sched.pauseTrigger(triggerName, triggerGroupName);
    sched.unscheduleJob(triggerName, triggerGroupName);
    sched.deleteJob(jobName, jobGroupName);
  }
  
  public static void removeJob(String jobName) throws SchedulerException {
    Log.getInstance().kernel().info("移除了" + jobName + "调度器");
    Scheduler sched = sf.getScheduler();
    sched.pauseTrigger(jobName, TRIGGER_GROUP_NAME);
    sched.unscheduleJob(jobName, TRIGGER_GROUP_NAME);
    sched.deleteJob(jobName, JOB_GROUP_NAME);
  }
}
